#vertex
#version 330

uniform mat4 matrix_model_view_projection;

layout(location = 0) in vec3 a_vertex;
layout(location = 1) in vec4 a_color;
layout(location = 2) in vec2 a_uv;

out vec4 v_color;
out vec2 v_uv;

void main()
{
	gl_Position = matrix_model_view_projection * vec4(a_vertex, 1.0);
	v_color = a_color;
	v_uv = a_uv;
}

#fragment
#version 330

uniform sampler2D diffuse_map;
uniform float gamma;

in vec4 v_color;
in vec2 v_uv;

out vec4 o_color;

void main()
{
	vec3 saturated_color = texture(diffuse_map, vec2(0.5, v_color.r)).rgb;
	vec3 color = mix(vec3(v_uv.y), v_uv.y * saturated_color, v_uv.x);
	o_color = vec4(pow(color, vec3(gamma)), 1.0);
}
