#vertex
#version 330

uniform mat4 matrix_model_view_projection;
uniform vec4 diffuse;
uniform vec4 uv_rect;
uniform float gamma;

layout(location = 0) in vec3 a_vertex;
layout(location = 1) in vec4 a_color;
layout(location = 2) in vec2 a_uv;

out vec4 v_color;
out vec2 v_uv;

void main()
{
	gl_Position = matrix_model_view_projection * vec4(a_vertex, 1.0);
	v_color = vec4(pow(a_color.rgb, vec3(gamma)), a_color.a) * diffuse;
	v_uv = a_uv * uv_rect.zw + uv_rect.xy;
}

#fragment
#version 330

uniform sampler2D diffuse_map;
uniform float gamma;

in vec4 v_color;
in vec2 v_uv;

out vec4 o_color;

void main()
{
	vec4 color = texture(diffuse_map, v_uv);
	o_color = vec4(pow(color.rgb, vec3(gamma)), color.a) * v_color;
}
